      program integ1
!
!        integrate  sin(x) from 0 to xival 
!        with different integration schemes:
!        Trapeziodal, Simpson, Gauss
!
      implicit none

      integer :: nxmt,nxms,ng,nsxx,ngp
      integer :: kread, kwrite
      integer :: i,nxmx,nxmx1,nxmx2
      double precision :: pi,sxx,wxx,u,w
      double precision :: xival,dx,sum,d43,d23
 
!        integration points
      parameter (nxmt=30,nxms=20)
      parameter (ng=8)
 
      parameter (nsxx=2000)
      parameter (ngp=64)
      parameter (pi=3.141592654d0)
      parameter (kread=5,kwrite=6)
 
      dimension sxx(nsxx),wxx(nsxx)
      dimension u(ngp),w(ngp)
 
      xival=1.d0*pi
!
!
!       Integration with Trapezoidal rule
!
!
!       set up grid for trapezoidal rule
!
      nxmx=nxmt/2
      nxmx=nxmx*2+1
 
      dx=xival/float(nxmx-1)
 
      wxx(1)=dx*0.5d0
      wxx(nxmx)=dx*0.5d0
      sxx(1)=0.d0
      sxx(nxmx)=sin(xival)
 
      nxmx1=nxmx-1
 
      do 10 i=1,nxmx1
      sxx(i)=float(i-1)*dx
   10 wxx(i)=dx
!
!       integrate
!
      sum=0.d0
      do 20 i=1,nxmx
   20 sum=sum + sin(sxx(i))*wxx(i)
  
 
      write (kwrite,10000) nxmx
      write (kwrite,10002) sum
!
! 
!
!       Simpson integration
!
!       set up grid for Simpson integration
!
      nxmx=nxms/4
      nxmx=4*nxmx + 1
 
      dx=xival/float(nxmx-1)
 
      d43=4.d0/3.d0
      d23=2.d0/3.d0
 
      wxx(1)=dx/3.d0
      wxx(nxmx)=dx/3.d0
      sxx(1)=0.d0

      sxx(nxmx)=sin(xival)
 
      nxmx1=nxmx-1
      nxmx2=nxmx-2
 
      do  i=2,nxmx1,2
      sxx(i)=float(i-1)*dx
      wxx(i)=d43*dx
      end do
 
      do  i=3,nxmx2,2
      sxx(i)=float(i-1)*dx
      wxx(i)=d23*dx
      end do
!
!       integrate
!
      sum=0.d0
      do  i=1,nxmx
      sum=sum + sin(sxx(i))*wxx(i)
      end do
 
 
      write (kwrite,10001) nxmx
      write (kwrite,10002) sum
!
!
!        gauss integration
!
!        get gauss points and weights
!
      call gauleg (0.d0,xival,u,w,ng)
 
 
 
      do i=1,ng
      sxx(i)=u(i)
      wxx(i)=w(i)
      end do
!
!
!       integrate
!
      sum=0.d0
      do  i=1,ng
      sum=sum + sin(sxx(i))*wxx(i)
      end do
 
 
      write (kwrite,10003) ng
      write (kwrite,10002) sum
 
 
10000 format(t5,'Integration with Trapezoidal rule ',/t5,'number of inte  &
     &gration points:',i7)
10001 format(t5,'Integration with Simpsons rule ',/t5,'number of integra  &
     &tion points:',i7)
10002 format(t10,'result:',d12.5,//)
10003 format(t5,'Gauss integration - one interval',/t5,'number of integr  &
     &ation points:',i7)
 
      stop 
      end

